<?php

# Required File Includes
include("../../../includes/functions.php");
include("../../../includes/gatewayfunctions.php");
include("../../../includes/invoicefunctions.php");

if (file_exists('../../../dbconnect.php')) {
	include '../../../dbconnect.php';
} else if (file_exists('../../../init.php')) {
	include '../../../init.php';
}

include_once "../lib-servipag/flowlib.php";
include_once "../lib-servipag/flowlib.whmcs.php";

$gatewaymodule = "flowservipag"; # Enter your gateway module name here replacing template

$GATEWAY = getGatewayVariables($gatewaymodule);

if (!$GATEWAY["type"]) die("Module Not Activated"); # Checks gateway module is active before accepting callback

$privatekey = $GATEWAY['secret'];
$comercio = $GATEWAY['receiver_id'];

$errorResponse = array('status' => 'RECHAZADO', 'c' => $comercio);
$acceptResponse = array('status' => 'ACEPTADO', 'c' => $comercio);

$data = $_POST['response'];
$data = str_replace('&amp;', '&', $data);
try {
	$params = flowservipag_sign_validate($data);
} catch (Exception $e) {
	error_log($e->getMessage());
	echo flowservipag_build_response($privatekey, $errorResponse);
	return;
}

$error = flowservipag_aget($params, 'error');
if ($error != null) {
	error_log("Error recibido: $error");
	echo flowservipag_build_response($privatekey, $acceptResponse);
	return;
}

$status = flowservipag_aget($params, 'status');
if ($status == null) {
	error_log("Peticion incorrecta (sin status)");
	echo flowservipag_build_response($privatekey, $errorResponse);
	return;
}

$order_id = flowservipag_aget($params, 'kpf_orden');
$amount   = flowservipag_aget($params, 'kpf_monto');
$notification_id = flowservipag_aget($params, 'kpf_flow_order');

$invoiceid = checkCbInvoiceID($order_id,$GATEWAY["name"]); # Checks invoice ID is a valid invoice number or ends processing

checkCbTransID($notification_id); # Checks transaction number isn't already in the database and ends processing if it does

if ($status == 'EXITO') {
	$fee = 0;
	addInvoicePayment($invoiceid,$notification_id,$amount,$fee,$gatewaymodule); # Apply Payment to Invoice: invoiceid, transactionid, amount paid, fees, modulename
	logTransaction($GATEWAY["name"],$_POST,"Successful"); # Save to Gateway Log: name, data array, status
} else {
	logTransaction($GATEWAY["name"],$_POST,"Unsuccessful"); # Save to Gateway Log: name, data array, status
}

echo flowservipag_build_response($privatekey, $acceptResponse);

?>
